#ifndef LOGPARSER_HPP
#define LOGPARSER_HPP
#include "Exceptions/LogFileNotOpenException.hpp"
#include "Exceptions/LogFileNotSupportedException.hpp"
#include <CAN_IDs.h>
#include <QFile>
#include <QList>
#include <QTextStream>
#include <qdebug.h>

class LogParser {
public:
    /**
     * @brief LogParser - Construtor.
     * @param filename - Log file name.
     * @param parseAsCSV - If set to true, the log file will be parsed as CSV Log file
     */
    LogParser(QString);

    /**
     * @brief parse() - parse the log file.
     */
    virtual void parse();

    QString getLogFilename();

    void appendTimestamp(ulong timestamp);

    void appendMessage(CANmessage msg);

    /**
     * @brief getMessages - Returns all the CANmessages parsed from the log file.
     */
    QVector<CANmessage>* getMessages();
    /**
     * @brief getTimestamps - Returns all the timestamps parsed from the log file.
     */
    QVector<ulong>* getTimestamps();

    ulong convertTimestamp(QString data);

private:
    /**
     * @brief logFilename - Name of the file (or path) to be parsed
     */
    QString logFilename;

    /**
     * @brief _times - Vector with all the timestamps
     */
    QVector<ulong>* _times;

    /**
     * @brief _messages - Vector with all the CAN Messages.
     */
    QVector<CANmessage>* _messages;
    /**
     * @brief parseDefaultCanMsg - Default parsing for log file line
     * @param list - log file line (Stringlist)
     * @return CANMsg generated by the line of the log file
     */
    CANmessage parseDefaultCanMsg(QStringList list);

    /**
     * @brief  parseCSVCanMsg - CSV parsing for log file line
     * @param list - log file line (Stringlist)
     * @return CANMsg generated by the line of the log file
     */
    CANmessage parseCSVCanMsg(QStringList list);
};

#endif // LOGPARSER_HPP
